;White Font Puts Routines (155 Bytes)
;These routines are able to use white font version of _vputmap and _vputs.
;It is necessary to include "ion.inc" because these routines use "ionPutSprite".
;
;wputmap - white font version of _vputmap
;wputs   - white font version of _vputs
;wputsml - multi lines version of wputs
;
;	Written by YUKI. [http://www.ticalc.org/archives/files/authors/70/7071.html]
;


;Inputs   : A = Charcter code, (pencol), (penrow)
;Outputs  : A character is drawn to the graph buffer by XOR sprite. Drawn position is affected by pencol and penrow.
;Destroies: ALL
wputmap:set 2,(iy+50) ;set fracDrawLFont,(iy+fontFlags)
	bcall(4CB1h) ;bcall(_LoadPattern)

	ld hl,wdata
	ld de,wdata+1
	ld bc,9-1
	xor a
	ld (hl),a
	ldir

	ld b,7
	ld de,845Ah+1
	ld hl,wdata
wpmlp:	ld a,(de)
	rlca
	or (hl)
	ld (hl),a
	ld a,(de)
	rlca
	inc hl
	inc hl
	or (hl)
	ld (hl),a
	dec hl
	ld a,(de)
	ld c,a
	ld a,(hl)
	or c
	rlc c
	or c
	rlc c
	or c
	ld (hl),a
	inc de
	djnz wpmlp

	ld b,7
	ld de,845Ah+1
	ld hl,wdata+1
wpmlp2:	ld a,(de)
	rlca
	xor (hl)
	ld (hl),a
	inc hl
	inc de
	djnz wpmlp2

	res 2,(iy+50) ;fracDrawLFont,(iy+fontFlags)
	ld de,(pencol)
	ld a,d
	ld l,e
	ld ix,wdata
	ld b,9
	call ionPutSprite
	ret


;Inputs   : HL = pointer of characters(0 terminated), (pencol), (penrow)
;Outputs  : Characters are drawn to the graph buffer by XOR sprite. Drawn position is affected by pencol and penrow.
;Destroies: ALL
wputs:	ld a,(hl)
	or a
	jp z,wputs_e
	push hl
	call wputmap
	ld a,(penrow)
	add a,7
	ld (penrow),a
	pop hl
	inc hl
	jr wputs
wputs_e:inc hl
	ret


;Inputs   : HL = pointer of characters(end of line is 0, lines terminated is 0,0), (pencol), (penrow)
;Outputs  : Characters are drawn to the graph buffer by XOR sprite. Drawn position is affected by pencol and penrow.
;Destroies: ALL
wputsml:ld a,(penrow)
	ld (wpenrow),a
wputs2:	xor a
	cp (hl)
	jp z,wputs2_e
	call wputs
	ld a,(wpenrow)
	ld (penrow),a
	ld a,(pencol)
	add a,10
	ld (pencol),a
	jp wputs2
wputs2_e:
	inc hl
	ret
wpenrow:.db 0

wdata:	.db 0,0,0,0,0,0,0,0,0


